{% load static %}
{% load i18n %}

{% block content %}

    <div id="map"></div>

    <!-- Leaflet -->
    <link rel="stylesheet" href="{% static 'vendor/leaflet/leaflet.css' %}" media="screen">
    <script src="{% static 'vendor/leaflet/leaflet.js' %}"></script>
    <!-- Custom Leaflet Toolbar -->
    <script src="{% static 'vendor/leaflet/L.Control.CstmToolbar.js' %}"></script>

    {% if station_types %}
    <!-- Leaflet Point in Polygon -->
    <script src="{% static 'vendor/leaflet/wise-leaflet-pip.js' %}"></script>
    <!-- Leaflet Marker Cluster
    <link rel="stylesheet" href="{% static 'vendor/leaflet/MarkerCluster.Default.css' %}" media="screen">
    <link rel="stylesheet" href="{% static 'vendor/leaflet/MarkerCluster.css' %}" media="screen">
    <script src="{% static 'vendor/leaflet/leaflet.markercluster.js' %}"></script>-->

    <!-- Used to freeze screen before response -->
    <div id="divModal_empty" class="modal fade" role="dialog" data-backdrop="static" data-keyboard="false">
      <div class="vertical-alignment-helper">
        <div class="modal-dialog">
        </div>
      </div>
    </div>
    {% endif %}

    <script type="text/javascript">
        // Global vars
        var info = null;
        var bboxLayer = null;
        var bboxTypes = {{ bbox_types|safe }};
        var boundariesLayer = null;
        var boundaryTypes = {{ boundary_types|safe }};
        var contourValues = [];
        {% if station_types %}
        var pointsGroup = null;
        var linesGroup= null;
        var stationTypes = {{ station_types|safe }};
        var pointState = true; // used only if 'addpoint' tool is added to leaflet custom toolbar
        {% endif %}

        // Basemap Tiles
        var Esri_WorldGrayCanvas = L.tileLayer('https://server.arcgisonline.com/ArcGIS/rest/services/Canvas/World_Light_Gray_Base/MapServer/tile/{z}/{y}/{x}', {
            attribution: 'Tiles &copy; Esri &mdash; Esri, DeLorme, NAVTEQ',
            maxZoom: 16
        });
        var Esri_WorldStreetMap = L.tileLayer('https://server.arcgisonline.com/ArcGIS/rest/services/World_Street_Map/MapServer/tile/{z}/{y}/{x}', {
            attribution: 'Tiles &copy; Esri &mdash; Source: Esri, DeLorme, NAVTEQ, USGS, Intermap, iPC, NRCAN, Esri Japan, METI, Esri China (Hong Kong), Esri (Thailand), TomTom, 2012'
        });
        var Esri_WorldImagery = L.tileLayer('https://server.arcgisonline.com/ArcGIS/rest/services/World_Imagery/MapServer/tile/{z}/{y}/{x}', {
            attribution: 'Tiles &copy; Esri &mdash; Source: Esri, i-cubed, USDA, USGS, AEX, GeoEye, Getmapping, Aerogrid, IGN, IGP, UPR-EGP, and the GIS User Community'
        });

        var baseMaps = {
            "Esri WorldStreetMap": Esri_WorldStreetMap,
            "Esri WorldGrayCanvas": Esri_WorldGrayCanvas,
            "Esri WorldImagery": Esri_WorldImagery
        };

        // Build Map
        var map = L.map('map', {
            minZoom: 2,
            maxZoom: 16,
            zoomControl: false,
            zoomDelta: 0.5,
            zoomSnap: 0.5,
            layers: [Esri_WorldStreetMap],
            attributionControl: true,
        });

        // Prepare Layers
        var overlayMaps = {};
        {% if bbox %}
        // Add BBox
        bboxLayer = L.geoJson({{ bbox|safe }}, {
            style: function(feature) {
                var borderColor = '#333';
                bboxTypes.forEach(function(item, index) {
                    if (item['type'] == feature.properties.bbox_type || item['forcing'] == feature.properties.forcing_source) borderColor = item['color'];
                });
                return {
                    color: borderColor,
                    weight: 2,
                    fillOpacity: .20,
                    fillColor: '#ffffff',
                    dashArray: '20,15',
                    lineJoin: 'round',
                    interactive: false, // disables pointer events on the layer's features
                };
            }
        });
        {% if not print %}
        bboxLayer.addTo(map);
        {% endif %}

        {% endif %}

        {% if bathymetry %}
        // Add contours
        contoursLayer = L.geoJson({{ bathymetry|safe }}, {
            onEachFeature: onEachFeatureContours,
            style: function(feature) {
                return {color: feature.properties.color, weight: 0, fillOpacity: 0.45, opacity: 0.45};
            }
        }).addTo(map);
        {% endif %}

        {% if boundaries %}
        // Add Boundaries
        boundariesLayer = L.geoJson({{ boundaries|safe }}, {
            onEachFeature: onEachFeatureBoundaries,
            style: function(feature) {
                var borderColor = '#333';
                boundaryTypes.forEach(function(item, index) {
                    if (item['type'] == feature.properties.type) borderColor = item['color'];
                });
                //return {className: 'boundaryfeature', color: borderColor, weight: 4};
                return {color: borderColor, weight: 4};
            }
        }).addTo(map);
        {% endif %}

        {% if station_types %}
        // Add auxiliary group layer to group connecting line
        linesGroup = new L.layerGroup();
        map.addLayer(linesGroup);

        // Add Stations
        pointsGroup = new L.layerGroup(); // new L.markerClusterGroup({ disableClusteringAtZoom: 10 }); // not using markercluster at the moment
        L.geoJson({{ stations|safe }}, {
            onEachFeature: onEachFeatureStations,
            pointToLayer: function(feature, latLng) {
                // Circle settings
                var fillColor = '#333', rad = 5, fillOpacity = 0.8, weight = 2, rise = true, dashArray = null;

                // Attributes
                var code = feature.properties.code;
                var stype = feature.properties.type;
                var name = feature.properties.name;
                var cstation = feature.properties.cstation;
                var lat = latLng.lat;
                var lon = latLng.lng;

                // Get station color
                stationTypes.forEach(function(item, index) {
                    if (stype == item['type']) fillColor = item['color'];
                });

                // Increase comparision station radius to overlay observation station
                if (stype == 'C') rad = 10;

                // If observation station
                if (stype == 'O') {
                    rise = false;
                } else {
                    // Station not marked on table - dash it
                    if (feature.properties.chk == 0) dashArray = '5,5';
                }

                // Set marker options
                var pointMarkerOptions = {radius: rad, fillColor: fillColor, color: "#333", weight: weight,
                    opacity: fillOpacity, fillOpacity: fillOpacity, riseOnHover: rise, dashArray: dashArray};

                // Build popup info
                var popupCtn = buildPopup(code, stype, name, cstation, feature);

                // Create Marker
                var pointMarker = L.circleMarker(latLng, pointMarkerOptions).bindPopup(popupCtn);
                pointMarker._leaflet_id = code;
                pointsGroup.addLayer(pointMarker);

                return pointMarker;
            }
        });

        map.addLayer(pointsGroup);

        // Load Contour polygons to check if click on map is inside any of them
        {% if bbox_poly %}
        var polyLayer = L.polygon({{ bbox_poly|safe }});
        {% else %}
        var polyLayer = null;
        {% endif %}
        {% if bbox_islands %}
        var islandsLayer = {{ bbox_islands|safe }};
        {% else %}
        var islandsLayer = null;
        {% endif %}

        map.on('click', onMapClick);

        function onMapClick(e) {
          if (pointState) {
            if (!stationsMaxLimit()) {
              // Show empty modal - process can take some time
              $('#divModal_empty').modal('show');

              // Set some timeout to allow modal above to render
              setTimeout( function() {
                // If point is inside show form or else show error message
                var pointIN = insideBBox(e.latlng);

                // Hide empty modal and return response
                $('#divModal_empty').modal('hide');

                if (pointIN) {
                  // Reset form before opening modal form
                  clearForm();

                  $('#id_lat').val(e.latlng.lat.toFixed(6));
                  $('#id_lon').val(e.latlng.lng.toFixed(6));

                  // Change Form's Title
                  $('#formLabel').html('{% trans "Nova Estação" %}');
                  $('#applyLabel').html('{% trans "Adicionar" %}');
                  $("#sid").val(null);

                  // Show form
                  $('#divModal_station').modal('show');
                  $("#form_errors").hide();
                } else {
                  $('#msg_str').html("{% trans 'A nova estação tem de estar posicionada dentro da malha!' %}");
                  $('#divModal_msg').modal('show');
                }
              }, 10);
            } else {
                $('#msg_str').html('{% trans "Atingiu o limite máximo de estações que pode usar num modelo " %} ('+ max_stations + ').');
                $('#divModal_msg').modal('show');
            }
          }
        }

        function insideBBox(point) {
          // First check if point is in island, if not check if in bbox_poly
          if (islandsLayer) {
            for (var i=0; i<islandsLayer.length; i++) {
                var temppoly = L.polygon(islandsLayer[i]);
                if (temppoly.contains(point)) {
                    return false;
                }
            }

            if (polyLayer.contains(point)) {
                return true;
            } else {
                return false;
            }
          } else {
              if (polyLayer.contains(point)) {
                return true;
              } else {
                return false;
              }
          }
        }
        {% endif %}

        // Add Overlays to map
        {% if boundaries %}
        overlayMaps['{% trans "Fronteiras" %}'] = boundariesLayer;
        {% endif %}

        {% if bathymetry %}
        overlayMaps['{% trans "Profundidade" %}'] = contoursLayer;
        {% endif %}

        {% if station_types %}
        overlayMaps['{% trans "Estações" %}'] = pointsGroup;
        {% endif %}

        {% if bathymetry or boundaries %}
        {% if not print %}
        // Add control that shows state info on hover
        info = L.control({ position: 'topright' });
        info.onAdd = function (map) {
            this._div = L.DomUtil.create('div', 'info');
            this.update();
            return this._div;
        };
        info.update = function (val, layer) {
            if (val) {
                if (layer == 'B') {
                    this._div.innerHTML = '<strong>{% trans "Fronteira" %}</strong><br/><span>' + val + '</span>';
                } else if (layer == 'C') {
                    this._div.innerHTML = '<strong>{% trans "Profundidade" %}</strong><br/><span>[' + val + ' m]</span>';
                } else if (layer == 'S') {
                    this._div.innerHTML = '<strong>{% trans "Estação" %}</strong><br/><span>' + val + '</span>';
                }
            } else {
                this._div.innerHTML = '<strong>Info</strong><br/>...';
            }
        };
        info.addTo(map);
        {% endif %}

        // Add legend
        var legend = L.control({ position: 'topright' });
        legend.onAdd = function (map) {
            var div = L.DomUtil.create('div', 'legend');
            div.innerHTML = '<span class="title">{% trans "Legenda" %}</span>';

            {% if bbox and not print %}
            //BBox Legend
            div.innerHTML += '<span class="subtitle">{% trans "Zona" %}</span>';
            labels = [];
            bboxTypes.forEach(function(item) {
                labels.push('<span><i class="square" style="border: dashed 2px ' + item['color'] + '"></i> ' + item['label'] + '</span>');
            });
            labels.reverse();   //Global firs
            div.innerHTML += labels.join('<br/>');
            {% endif %}

            {% if boundaries %}
            //Boundaries Legend
            div.innerHTML += '<span class="subtitle">{% trans "Fronteira" %}</span>';
            labels = [];
            boundaryTypes.forEach(function(item) {
                labels.push('<span><i class="line" style="background-color:' + item['color'] + '"></i> ' + item['label'] + '</span>');
            });
            div.innerHTML += labels.join('<br/>');
            {% endif %}

            {% if bathymetry %}
            //Bathymetry Legend
            var range = false;   // determine if range or scalar legend
            labels = [];
            div.innerHTML += '<span class="subtitle">{% trans "Profundidade" %}</span>';
            contourValues.forEach(function(item, index) {
                var vals = item[1].split(' - ');
                if (index == 0) {
                    labels.push('<span class="flex"><i class="square" style="background-color:' + item[0] + '"></i><em>' + vals[0] +' m</em></span>');
                } else if (index == contourValues.length-1) {
                    labels.push('<span class="flex"><i class="square" style="background-color:' + item[0] + '"></i><em>' + vals[1] +' m</em></span>');
                } else {
                    labels.push('<span class="flex"><i class="square" style="background-color:' + item[0] + '"></i></span>');
                }
            });
            div.innerHTML += labels.join('') + '<br/>';
            contourValues = null; // no need to save this global variable after legend is created
            {% endif %}

            {% if station_types %}
            //Stations Legend
            div.innerHTML += '<span class="subtitle">{% trans "Estação" %}</span>';
            labels = [];
            stationTypes.forEach(function(item) {
                labels.push('<span><i class="circle" style="background-color:' + item['color'] + '"></i> ' + item['label'] + '</span>');
            });
            div.innerHTML += labels.join('<br/>');
            {% endif %}

            return div;
        };

        // Add Legend to map
        legend.addTo(map);

        // Prevent map dragging on action over legend
        legend.getContainer().addEventListener('mouseover', function() {
            map.dragging.disable();
        });
        legend.getContainer().addEventListener('mouseout', function() {
            map.dragging.enable();
        });
        {% endif %}

        {% if not print %}
        // Build Custom Toolbar
        var tlbButtons = [
            {'id': 'zoomin', 'classes': 'glyphicon glyphicon-plus', 'title': '{% trans "Aproximar" %}'},
            {'id': 'zoomout', 'classes': 'glyphicon glyphicon-minus', 'title': '{% trans "Afastar" %}'},
            {'id': 'fullout', 'classes': 'glyphicon glyphicon-globe', 'title': '{% trans "Afastar à zona de atuação" %}'}
        ];

        {% if bathymetry or boundaries %}
        tlbButtons.push({'id': 'zoomlayer', 'classes': 'glyphicon glyphicon-search', 'title': '{% trans "Aproximar aos temas" %}'});
        {% endif %}

        {% if station_types %}
        tlbButtons.push({'id': 'addpoint', 'classes': 'glyphicon glyphicon-screenshot', 'title': '{% trans "Ativar/desativar ferramenta Nova estação" %}', 'active': true});
        {% endif %}

        // Add Custom Toolbar to map
        L.control.cstmtoolbar({
            id: 'map_tlb',
            position: 'topleft',
            classes : 'btn-group-vertical btn-group-sm',
            buttons: tlbButtons
        }).addTo(map);

        // Add custom LayerControl
        L.control.layers(
            baseMaps, overlayMaps, { position: 'topleft' }
        ).addTo(map);

        // Tooltips Setup (for Intro.js) not on last step
        {% if step < 7 %}
            $('#map_tlb').attr("data-step", 1);
            $('#map_tlb').attr("data-intro", "{% trans 'Opções de Zoom do mapa' %}");

            $('div.leaflet-control-layers').attr("data-step", 2);
            $('div.leaflet-control-layers').attr("data-intro", "{% trans 'Opções de Tema/Camadas visíveis no mapa' %}");

            $('div.leaflet-control-container .info').attr("data-step", 3);
            $('div.leaflet-control-container .info').attr("data-intro", "{% trans 'Passe com o rato pelas Camadas para ver detalhes' %}");

            $('div.leaflet-control-container .legend').attr("data-step", 4);
            $('div.leaflet-control-container .legend').attr("data-intro", "{% trans 'Consulte a legenda das Camadas' %}");
        {% endif %}
        {% endif %}

        function onEachFeatureContours(feature, layer) {
          contourValues.push([feature.properties.color, feature.properties.depth]);
          layer.on({
            mouseover: function(){ info.update(feature.properties.depth, 'C'); },
            mouseout: function(){ info.update(); },
          });
        }

        function onEachFeatureBoundaries(feature, layer) {
          layer._leaflet_id = feature.properties.code;  // reference features to allow their selection from outside
          layer.on({
            mouseover: highlightBoundary,
            mouseout: resetBoundary,
          });
        }

        function onEachFeatureStations(feature, layer) {
          layer.on({
            mouseover: highlightStation,
            mouseout: resetStation,
          });
        }

        function highlightBoundary(e) {
            var layer = e.target;
            layer.setStyle({
                weight: 9,
                opacity: 0.6,
            });
            if (!L.Browser.ie && !L.Browser.opera && !L.Browser.edge) {
                layer.bringToFront();
            }
            var bid = layer.feature.properties.code;
            info.update(bid, 'B');
            $("#forcings_table td.bid:contains('" + bid + "')").parent().addClass('highlight');
        }

        function resetBoundary(e) {
            var layer = e.target;
            layer.setStyle({
                weight: 4,
                opacity: 1,
            });

            info.update();
            $("#forcings_table tr").removeClass('highlight');
        }

        function highlightStation(e) {
            var layer = e.target;
            var sid = layer._leaflet_id;
            layer.setStyle({
                weight: 4,
            });
            if (!L.Browser.ie && !L.Browser.opera && !L.Browser.edge) {
                layer.bringToFront();
            }
            if (layer.feature) {
                var name = layer.feature.properties.name;
            } else {
                var name = layer.properties.name;
            }

            info.update(name, 'S');
            $('[data-code=' + sid + ']').parent().parent().addClass('highlight');
        }

        function resetStation(e) {
            var layer = e.target;
            layer.setStyle({
                weight: 2,
            });

            info.update();
            $("#stations_table tr").removeClass('highlight');
        }

        function buildPopup(sid, stype, name, cstation, feature) {
            // Builds popup html content (used on stations geojson load and whenever user creates new stations)
            var popupCtn = '<p>' + name + '</p>';
            if (stype == 'O' || stype == 'C') {
                var oid = sid;
                // Get comparison station info
                if (stype == 'C') {
                    oid = 'O_' + sid.split('_')[1];
                    popupCtn += '<hr/><strong>{% trans "Comparação" %}</strong><br/>' + cstation;
                }
                popupCtn += '<hr/><strong>{% trans "Código" %}</strong> ' + oid.replace('O_', '');
                popupCtn += '<br/><strong>{% trans "Fonte" %}</strong> ' + feature.properties.source;
                popupCtn += '<br/><strong>{% trans "Origem" %}</strong> ' + feature.properties.owner;
                popupCtn += '<br/><strong>{% trans "Categorias" %}</strong> ' + feature.properties.paramsgroup;
                popupCtn += '<br/><strong>{% trans "Parâmetros" %}</strong> ' + feature.properties.params;
                popupCtn += '<br/><strong>{% trans "Última observação" %}</strong> ' + feature.properties.lastdate;
            }
            if (stype == 'C' || stype == 'V') {
                popupCtn += '<hr/><button class="btn btn-danger btn-xs" onclick="removeStation(&quot;' + sid + '&quot;);">{% trans "Remover" %}</button>';
            } else {
                if (feature.properties.inbbox === 1) popupCtn += '<br/><hr/><button class="btn btn-success btn-xs" onclick="addStation(&quot;' + oid + '&quot;)">{% trans "Adicionar" %}</button>';
            }
            return popupCtn;
        }

        function createLine(station, cstation, lid, dashed) {
            // Build line between points and add to map
            var lpoints = [];
            lpoints.push(station);
            lpoints.push(cstation);

            var dash = null;
            if (dashed) dash = '5,5';

            var connectline = new L.polyline(lpoints, {
                color: 'red',
                weight: 1,
                opacity: 1,
                dashArray: dash
            });
            connectline._leaflet_id = lid;
            linesGroup.addLayer(connectline);
        }

        // On Document Ready
        $(function(){
            // Last action zoom to layer if layer exists and no errors
            {% if not errors %}
            if (boundariesLayer !== null) {
                map.fitBounds(boundariesLayer.getBounds(), {'padding': [50,50]});
            } else {
                if (bboxLayer !== null) {
                    map.fitBounds(bboxLayer.getBounds());
                } else {
                    map.fitWorld();
                }
            }
            {% else %}
            if (bboxLayer !== null) {
                map.fitBounds(bboxLayer.getBounds());
            } else {
                map.fitWorld();
            }
            {% endif %}
        });
    </script>
{% endblock content %}